using System.Text.Json;
using System.Text.Json.Serialization;

namespace File_Watcher.Models;

public record AppSettings(CompassConfiguration CompassConfiguration,
                          DriveConfiguration DriveConfiguration,
                          EAFLogConfiguration EAFLogConfiguration,
                          EDADatabaseConfiguration EDADatabaseConfiguration,
                          IsoConfiguration IsoConfiguration,
                          MetrologyConfiguration MetrologyConfiguration,
                          NugetConfiguration NugetConfiguration,
                          SerialConfiguration SerialConfiguration,
                          StratusConfiguration StratusConfiguration,
                          TransmissionControlProtocolConfiguration TransmissionControlProtocolConfiguration,
                          WaferCounterConfiguration WaferCounterConfiguration,
                          string BuildNumber,
                          string Company,
                          string GitCommitSeven,
                          string Helper,
                          int MillisecondsDelay,
                          string WatchDirectory)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, AppSettingsSourceGenerationContext.Default.AppSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(AppSettings))]
internal partial class AppSettingsSourceGenerationContext : JsonSerializerContext
{
}